#include <cstdlib>
#include <cmath>

//pc:
#include <direct.h>

#include <sys/stat.h>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include <algorithm>
#include <vector>

#include "Umgebung.h"

#include "Tools.h"
#include "FDR_portfolio.h"
#include "Rom_Wolf_portfolio.h"
#include "Strategies.h"
#include "Perf_tools.h"
#include "FDR_tools.h"

using namespace std;

double DJ[TT_];
double RF[TT_];
double DJ_Returns[TT_];
double OBVI[TT_];
long IDX[B_][N_];

double Perfs[nb_perf_measures_][nb_strats_];
double Perfs_B[nb_perf_measures_][B_][nb_strats_];

int SSS[nb_strats_][N_];

double NBshort_tmp[nb_strats_];
double NBshort[nb_strats_];

double pvalues[nb_perf_measures_][nb_strats_];

int FDR_port_1[nb_strats_];
int FDR_port_5[nb_strats_];
int FDR_port_10[nb_strats_];
int FDR_port_20[nb_strats_];
int FDR_port_1_b[nb_strats_];
int FDR_port_5_b[nb_strats_];
int FDR_port_10_b[nb_strats_];
int FDR_port_20_b[nb_strats_];
int RW_port[nb_strats_];
int Best_port[nb_strats_];

int FDR_port_1_expost[nb_strats_];
int FDR_port_5_expost[nb_strats_];
int FDR_port_10_expost[nb_strats_];
int FDR_port_20_expost[nb_strats_];
int FDR_port_1_b_expost[nb_strats_];
int FDR_port_5_b_expost[nb_strats_];
int FDR_port_10_b_expost[nb_strats_];
int FDR_port_20_b_expost[nb_strats_];
int RW_port_expost[nb_strats_];
int Best_port_expost[nb_strats_];

double SR_rets_FDR_port_1[TT_];
double SR_rets_FDR_port_5[TT_];
double SR_rets_FDR_port_10[TT_];
double SR_rets_FDR_port_20[TT_];
double SR_rets_RW_port[TT_];
double SR_rets_best_port[TT_];
double SR_rets_best_rule[TT_];
double SR_rets_BRC_rule[TT_];

double SR_rets_FDR_port_1_expost[TT_];
double SR_rets_FDR_port_5_expost[TT_];
double SR_rets_FDR_port_10_expost[TT_];
double SR_rets_FDR_port_20_expost[TT_];
double SR_rets_RW_port_expost[TT_];
double SR_rets_best_port_expost[TT_];
double SR_rets_best_rule_expost[TT_];
double SR_rets_BRC_rule_expost[TT_];

int FDR_port_size_1[1000];
int FDR_port_size_5[1000];
int FDR_port_size_10[1000];
int FDR_port_size_20[1000];
int RW_port_size[1000];

int FDR_port_size_1_expost[1000];
int FDR_port_size_5_expost[1000];
int FDR_port_size_10_expost[1000];
int FDR_port_size_20_expost[1000];
int RW_port_size_expost[1000];

double FDR_plus_5_b[1000];
double sigma_FDR_plus_5_b[1000];

double FDR_plus_5_b_expost[1000];
double sigma_FDR_plus_5_b_expost[1000];

//template <class T>
//void to_string(string & result, const T & t) {
//	ostringstream oss; // create a stream
//	oss << t; // insert value to stream
//	result=oss.str(); // extract value and write it to result
//}

int main() {

	//begin settings +++++++++++++++++++++++++++++++++++++++++++++++
	int i_perf=0;
	//0 for average log return
	//1 for Sharpe ratio (computed using arith retuns)

	int tcindic=-1;
	//0 for no tc
	//1 for low tc
	//2 for high tc
	//3 for very low tc
	//-1 for custom

	int freq=12; //1 month rebalancing
	//int freq=2; //6 months rebalancing

	double tc,lf;
	string string_tc;

	if(tcindic==0){
		string_tc="noTC";
		tc=0;
		lf=0/252;
	} else if(tcindic==1) {
		string_tc="TClow";
		if(atoi(period_.c_str())<=3) {
			tc=0.005;
			lf=0.0025/252;
		} else {
			tc=0.0025;
			lf=0.0010/252;
		}
	} else if(tcindic==2) {
		string_tc="TChigh";
		if(atoi(period_.c_str())<=3) {
			tc=0.01;
			lf=0.005/252;
		} else {
			tc=0.0050;
			lf=0.0025/252;
		}
	} else if(tcindic==3) {
		string_tc="TCverylow";
		if(atoi(period_.c_str())<=3) {
			tc=0.0025;
			lf=0.00125/252;
		} else {
			tc=0.00125;
			lf=0.0005/252;
		}
	} else if(tcindic==-1) {
		string_tc="TC10";
		tc=0.001;
		lf=0;
	}


	//end settings +++++++++++++++++++++++++++++++++++++++++++++++

	long t, R;
	int best_rule_idx, best_rule_idx_expost;
	double BRC, BRC_expost;
	double pi_0;
	double FDR_plus_1, FDR_plus_5, FDR_plus_10, FDR_plus_20;
	double FDR_plus_1_b, FDR_plus_10_b, FDR_plus_20_b;
	double FDR_plus_1_expost, FDR_plus_5_expost, FDR_plus_10_expost, FDR_plus_20_expost;
	double FDR_plus_1_b_expost, FDR_plus_10_b_expost, FDR_plus_20_b_expost;

	double sigma_FDR_plus_1_b, sigma_FDR_plus_10_b, sigma_FDR_plus_20_b;
	double sigma_FDR_plus_1_b_expost, sigma_FDR_plus_10_b_expost, sigma_FDR_plus_20_b_expost;

	double average_FDR_plus_5_b, average_sigma_FDR_plus_5_b;
	double average_FDR_plus_5_b_expost, average_sigma_FDR_plus_5_b_expost;

	double perf_DJ=0;

	double perf_FDR_1=0;
	double perf_FDR_1_tmp=0;
	double perf_FDR_1_expost=0;
	double perf_FDR_1_expost_tmp=0;

	double perf_FDR_5=0;
	double perf_FDR_5_tmp=0;
	double perf_FDR_5_expost=0;
	double perf_FDR_5_expost_tmp=0;

	double perf_FDR_10=0;
	double perf_FDR_10_tmp=0;
	double perf_FDR_10_expost=0;
	double perf_FDR_10_expost_tmp=0;

	double perf_FDR_20=0;
	double perf_FDR_20_tmp=0;
	double perf_FDR_20_expost=0;
	double perf_FDR_20_expost_tmp=0;
	
	double perf_RW=0;
	double perf_RW_tmp=0;
	double perf_RW_expost=0;
	double perf_RW_expost_tmp=0;
	
	double perf_best_port=0;
	double perf_best_port_tmp=0;
	double perf_best_port_expost=0;
	double perf_best_port_expost_tmp=0;

	double perf_BRC=0;
	double perf_best_rule=0;
	double perf_BRC_expost=0;
	double perf_best_rule_expost=0;

	double oldproppos_FDR1, oldpropneg_FDR1, lastproppos_FDR1, lastpropneg_FDR1;
	double oldproppos_FDR5, oldpropneg_FDR5, lastproppos_FDR5, lastpropneg_FDR5;
	double oldproppos_FDR10, oldpropneg_FDR10, lastproppos_FDR10, lastpropneg_FDR10;
	double oldproppos_FDR20, oldpropneg_FDR20, lastproppos_FDR20, lastpropneg_FDR20;
	double oldproppos_RW, oldpropneg_RW, lastproppos_RW, lastpropneg_RW;
	double oldproppos_BestPort, oldpropneg_BestPort, lastproppos_BestPort, lastpropneg_BestPort;

	double oldproppos_FDR1_expost, oldpropneg_FDR1_expost, lastproppos_FDR1_expost, lastpropneg_FDR1_expost;
	double oldproppos_FDR5_expost, oldpropneg_FDR5_expost, lastproppos_FDR5_expost, lastpropneg_FDR5_expost;
	double oldproppos_FDR10_expost, oldpropneg_FDR10_expost, lastproppos_FDR10_expost, lastpropneg_FDR10_expost;
	double oldproppos_FDR20_expost, oldpropneg_FDR20_expost, lastproppos_FDR20_expost, lastpropneg_FDR20_expost;
	double oldproppos_RW_expost, oldpropneg_RW_expost, lastproppos_RW_expost, lastpropneg_RW_expost;
	double oldproppos_BestPort_expost, oldpropneg_BestPort_expost, lastproppos_BestPort_expost, lastpropneg_BestPort_expost;

	double nbshort_tmp=0;

	double nbshort_FDR1=0;
	double nbshort_FDR5=0;
	double nbshort_FDR10=0;
	double nbshort_FDR20=0;
	double nbshort_RW=0;
	double nbshort_BestPort=0;

	double nbshort_FDR1_expost=0;
	double nbshort_FDR5_expost=0;
	double nbshort_FDR10_expost=0;
	double nbshort_FDR20_expost=0;
	double nbshort_RW_expost=0;
	double nbshort_BestPort_expost=0;

	//Begin Reading Data +++++++++++++++++++++++++++++++++++++++++++++++
	cout << "Loading data..." << endl;
	string string_DJ=boulot_path_+"\\DATA\\dataprojet1\\data\\DJ_P"+period_+".txt";
	string string_RF=boulot_path_+"\\DATA\\dataprojet1\\data\\RF_P"+period_+".txt";
	string string_OBVI=boulot_path_+"\\DATA\\dataprojet1\\data\\OBVI_P"+period_+".txt";
	string string_IDX;
	if (freq==2) {
		string_IDX=boulot_path_+"\\DATA\\dataprojet1\\data\\IDX_Ppers6mois.txt";
	} else if (freq==12) {
		string_IDX=boulot_path_+"\\DATA\\dataprojet1\\data\\IDX_Ppers1mois.txt";
	}

	////mac:
	//string string_DJ=boulot_path_+"/data/DJ_P"+period_+".txt";
	//string string_RF=boulot_path_+"/data/RF_P"+period_+".txt";
	//string string_OBVI=boulot_path_+"/data/OBVI_P"+period_+".txt";
	//string string_IDX_6mois=boulot_path_+"/data/IDX_Ppers6mois.txt";

	ifstream InputFile_DJ;
	ifstream InputFile_RF;
	ifstream InputFile_OBVI;
	ifstream InputFile_IDX;

	InputFile_DJ.open(string_DJ.c_str());
	InputFile_RF.open(string_RF.c_str());
	InputFile_OBVI.open(string_OBVI.c_str());
	InputFile_IDX.open(string_IDX.c_str());

	string s_DJ;
	string s_RF;
	string s_OBVI;
	string s_IDX;

	for(t=0; t<TT_; t++) {
		getline(InputFile_DJ, s_DJ);
		getline(InputFile_RF, s_RF);
		getline(InputFile_OBVI, s_OBVI);

		DJ[t]=atof(s_DJ.c_str());
		RF[t]=atof(s_RF.c_str());
		OBVI[t]=atof(s_OBVI.c_str());
	}
	for(int b=0; b<B_; b++) {
		for(t=0; t<T_fin_year_/freq; t++) {
			getline(InputFile_IDX, s_IDX);
			IDX[b][t]=(int)atof(s_IDX.c_str());
		}
	}

	InputFile_DJ.close();
	InputFile_RF.close();
	InputFile_OBVI.close();
	InputFile_IDX.close();
	//End Reading Data +++++++++++++++++++++++++++++++++++++++++++++++

	//Begin Computing Returns +++++++++++++++++++++++++++++++++++++++++++++++
	for(t=1; t<TT_; t++) {
		DJ_Returns[t]=(DJ[t]-DJ[t-1])/DJ[t-1];
	}

	for(t=0; t<TT_; t++) {
		RF[t]=log(1+RF[t]/100)/252;
	}
	//End Computing Returns +++++++++++++++++++++++++++++++++++++++++++++++

	//Prepare output to file +++++++++++++++++++++++++++++++++++++++++++++++
	string resultats_path, ResultsFile_path, PortfoliosFile_path;

	//string SSSFile_path, DJFile_path, RFFile_path;

	//mac:
	//resultats_path=boulot_path_+"/resultats";
	//mkdir(resultats_path.c_str(), S_IRWXU | S_IRWXG);
	//resultats_path=resultats_path+"/pers_6M";
	//mkdir(resultats_path.c_str(), S_IRWXU | S_IRWXG);
	//pc:
	resultats_path=boulot_path_+"\\DATA\\dataprojet1\\resultats";
	_mkdir(resultats_path.c_str());
	if (freq==2) {
		resultats_path=resultats_path+"\\pers_6M";
	} else if (freq==12) {
		resultats_path=resultats_path+"\\pers_1M";
	}
	_mkdir(resultats_path.c_str());

	//string tmp;
	//to_string(tmp, B);
	//resultats_path=resultats_path+"\\B"+tmp;
	//_mkdir(resultats_path.c_str());

	ofstream ResultsFile, PortfoliosFile;

	//ofstream SSSFile, DJFile, RFFile;
		
	if(i_perf==0) {
		ResultsFile_path=resultats_path+"\\P"+period_+"_mu_"+string_tc+".txt";
		PortfoliosFile_path=resultats_path+"\\P"+period_+"_mu_"+string_tc+"_portfolios_10.txt";
	} else if (i_perf==1) {
		ResultsFile_path=resultats_path+"\\P"+period_+"_SR_"+string_tc+".txt";
		PortfoliosFile_path=resultats_path+"\\P"+period_+"_SR_"+string_tc+"_portfolios_10.txt";
		//SSSFile_path=resultats_path+"\\P"+period_+"_SR_"+string_tc+"_SSS.txt";
	}
	//DJFile_path=resultats_path+"\\P"+period_+"_SR_"+string_tc+"_DJ.txt";
	//RFFile_path=resultats_path+"\\P"+period_+"_SR_"+string_tc+"_RF.txt";

	ResultsFile.open(ResultsFile_path.c_str(), ofstream::out | ofstream::trunc);
	PortfoliosFile.open(PortfoliosFile_path.c_str(), ofstream::out | ofstream::trunc);
	//SSSFile.open(SSSFile_path.c_str(), ofstream::out | ofstream::trunc);
	//DJFile.open(DJFile_path.c_str(), ofstream::out | ofstream::trunc);
	//RFFile.open(RFFile_path.c_str(), ofstream::out | ofstream::trunc);

	//End Prepare output to file +++++++++++++++++++++++++++++++++++++++++++++++

	lastproppos_FDR1=0;
	lastpropneg_FDR1=0;
	lastproppos_FDR5=0;
	lastpropneg_FDR5=0;
	lastproppos_FDR10=0;
	lastpropneg_FDR10=0;
	lastproppos_FDR20=0;
	lastpropneg_FDR20=0;
	lastproppos_RW=0;
	lastpropneg_RW=0;
	lastproppos_BestPort=0;
	lastpropneg_BestPort=0;

	lastproppos_FDR1_expost=0;
	lastpropneg_FDR1_expost=0;
	lastproppos_FDR5_expost=0;
	lastpropneg_FDR5_expost=0;
	lastproppos_FDR10_expost=0;
	lastpropneg_FDR10_expost=0;
	lastproppos_FDR20_expost=0;
	lastpropneg_FDR20_expost=0;
	lastproppos_RW_expost=0;
	lastpropneg_RW_expost=0;
	lastproppos_BestPort_expost=0;
	lastpropneg_BestPort_expost=0;

	double nbshort_bestrule=0;
	double nbshort_bestrule_expost=0;

	for(int s=0; s<nb_strats_; s++) {
			NBshort[s]=0;
			NBshort_tmp[s]=0;
	}

	int i=0;
	for(R=251; R<TT_-2*T_fin_year_/freq; R+=T_fin_year_/freq) {  // check si < nÈcessaire (<= ...)
		cout << "i: " << i << endl;
		//select rules ex ante:
		Strats(strats_categ_, R, R+T_fin_year_/freq-1, SSS, DJ, OBVI);
		MultiPerfs(SSS, R, R+T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, IDX, Perfs, pvalues, Perfs_B);
		pi_0=Compute_PI_zero(pvalues[i_perf], lambda_);

		FDR_port_size_1[i]=FDRplus_control_portfolio(.01, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_1, FDR_port_1_b, &FDR_plus_1, &FDR_plus_1_b, &sigma_FDR_plus_1_b);
		FDR_port_size_5[i]=FDRplus_control_portfolio(.05, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_5, FDR_port_5_b, &FDR_plus_5, &FDR_plus_5_b[i], &sigma_FDR_plus_5_b[i]);
		FDR_port_size_10[i]=FDRplus_control_portfolio(.1, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_10, FDR_port_10_b, &FDR_plus_10, &FDR_plus_10_b, &sigma_FDR_plus_10_b);
		FDR_port_size_20[i]=FDRplus_control_portfolio(.2, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_20, FDR_port_20_b, &FDR_plus_20, &FDR_plus_20_b, &sigma_FDR_plus_20_b);
		RW_port_size[i]=RW_portfolio(Perfs[i_perf], Perfs_B[i_perf], RW_port, &best_rule_idx, &BRC);
		Best_portfolio(Perfs[i_perf], best_portfolio_size_, Best_port);

		//out-of-sample performance of rules selected ex ante:
		//!!!! pvalues, pi_0, Perfs changent!!!!!!
		Strats(strats_categ_, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, SSS, DJ, OBVI);
		MultiPerfs(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, IDX, Perfs, pvalues, Perfs_B, NBshort_tmp);
		pi_0=Compute_PI_zero(pvalues[i_perf], lambda_);

		for(int s=0; s<nb_strats_; s++) {
			NBshort[s]+=NBshort_tmp[s];
		}
		nbshort_bestrule+=NBshort_tmp[best_rule_idx];

		//for(int s=0; s<nb_strats_; s++) {
		//	for(t=R+T_fin_year_/freq-1; t<R+2*T_fin_year_/freq-1; t++) {
		//		SSSFile << SSS[s][t] << endl;
		//	}
		//}
		//for(t=R+T_fin_year_/freq-1; t<R+2*T_fin_year_/freq-1; t++) {
		//	DJFile << DJ_Returns[t+1] << endl;
		//	RFFile << RF[t+1] << endl;
		//}

		if(i_perf==0) {
			oldproppos_FDR1=lastproppos_FDR1;
			oldpropneg_FDR1=lastpropneg_FDR1;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_1, oldproppos_FDR1, oldpropneg_FDR1, &SR_rets_FDR_port_1[R+T_fin_year_/freq], &lastproppos_FDR1, &lastpropneg_FDR1);
			oldproppos_FDR5=lastproppos_FDR5;
			oldpropneg_FDR5=lastpropneg_FDR5;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_5, oldproppos_FDR5, oldpropneg_FDR5, &SR_rets_FDR_port_5[R+T_fin_year_/freq], &lastproppos_FDR5, &lastpropneg_FDR5);
			oldproppos_FDR10=lastproppos_FDR10;
			oldpropneg_FDR10=lastpropneg_FDR10;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_10, oldproppos_FDR10, oldpropneg_FDR10, &SR_rets_FDR_port_10[R+T_fin_year_/freq], &lastproppos_FDR10, &lastpropneg_FDR10);
			oldproppos_FDR20=lastproppos_FDR20;
			oldpropneg_FDR20=lastpropneg_FDR20;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_20, oldproppos_FDR20, oldpropneg_FDR20, &SR_rets_FDR_port_20[R+T_fin_year_/freq], &lastproppos_FDR20, &lastpropneg_FDR20);
			oldproppos_RW=lastproppos_RW;
			oldpropneg_RW=lastpropneg_RW;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RW_port, oldproppos_RW, oldpropneg_RW, &SR_rets_RW_port[R+T_fin_year_/freq], &lastproppos_RW, &lastpropneg_RW);
			oldproppos_BestPort=lastproppos_BestPort;
			oldpropneg_BestPort=lastpropneg_BestPort;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, Best_port, oldproppos_BestPort, oldpropneg_BestPort, &SR_rets_best_port[R+T_fin_year_/freq], &lastproppos_BestPort, &lastpropneg_BestPort);

			perf_best_rule+=Perfs[i_perf][best_rule_idx];
			if(BRC<alpha_) {
				perf_BRC+=Perfs[i_perf][best_rule_idx];
			}
		} else if (i_perf==1) {
			oldproppos_FDR1=lastproppos_FDR1;
			oldpropneg_FDR1=lastpropneg_FDR1;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_1, oldproppos_FDR1, oldpropneg_FDR1, &SR_rets_FDR_port_1[R+T_fin_year_/freq], &lastproppos_FDR1, &lastpropneg_FDR1, &nbshort_tmp);
			nbshort_FDR1+=nbshort_tmp;
			oldproppos_FDR5=lastproppos_FDR5;
			oldpropneg_FDR5=lastpropneg_FDR5;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_5, oldproppos_FDR5, oldpropneg_FDR5, &SR_rets_FDR_port_5[R+T_fin_year_/freq], &lastproppos_FDR5, &lastpropneg_FDR5, &nbshort_tmp);
			nbshort_FDR5+=nbshort_tmp;
			oldproppos_FDR10=lastproppos_FDR10;
			oldpropneg_FDR10=lastpropneg_FDR10;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_10, oldproppos_FDR10, oldpropneg_FDR10, &SR_rets_FDR_port_10[R+T_fin_year_/freq], &lastproppos_FDR10, &lastpropneg_FDR10, &nbshort_tmp);
			nbshort_FDR10+=nbshort_tmp;
			oldproppos_FDR20=lastproppos_FDR20;
			oldpropneg_FDR20=lastpropneg_FDR20;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_20, oldproppos_FDR20, oldpropneg_FDR20, &SR_rets_FDR_port_20[R+T_fin_year_/freq], &lastproppos_FDR20, &lastpropneg_FDR20, &nbshort_tmp);
			nbshort_FDR20+=nbshort_tmp;
			oldproppos_RW=lastproppos_RW;
			oldpropneg_RW=lastpropneg_RW;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, RW_port, oldproppos_RW, oldpropneg_RW, &SR_rets_RW_port[R+T_fin_year_/freq], &lastproppos_RW, &lastpropneg_RW, &nbshort_tmp);
			nbshort_RW+=nbshort_tmp;
			oldproppos_BestPort=lastproppos_BestPort;
			oldpropneg_BestPort=lastpropneg_BestPort;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, Best_port, oldproppos_BestPort, oldpropneg_BestPort, &SR_rets_best_port[R+T_fin_year_/freq], &lastproppos_BestPort, &lastpropneg_BestPort, &nbshort_tmp);
			nbshort_BestPort+=nbshort_tmp;

			ComputeReturnsOneStrat(SSS[best_rule_idx],  R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, &SR_rets_best_rule[R+T_fin_year_/freq]);
			if(BRC<alpha_) {
				ComputeReturnsOneStrat(SSS[best_rule_idx],  R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, &SR_rets_BRC_rule[R+T_fin_year_/freq]);
			} else {
				for(t=0; t<T_fin_year_; t++) {
					SR_rets_BRC_rule[R+T_fin_year_/freq+t]=RF[R+T_fin_year_/freq+t];
				}
			}
		}

		//select rules ex post:
		FDR_port_size_1_expost[i]=FDRplus_control_portfolio(.01, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_1_expost, FDR_port_1_b_expost, &FDR_plus_1_expost, &FDR_plus_1_b_expost, &sigma_FDR_plus_1_b_expost);
		FDR_port_size_5_expost[i]=FDRplus_control_portfolio(.05, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_5_expost, FDR_port_5_b_expost, &FDR_plus_5_expost, &FDR_plus_5_b_expost[i], &sigma_FDR_plus_5_b_expost[i]);
		FDR_port_size_10_expost[i]=FDRplus_control_portfolio(.1, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_10_expost, FDR_port_10_b_expost, &FDR_plus_10_expost, &FDR_plus_10_b_expost, &sigma_FDR_plus_10_b_expost);
		FDR_port_size_20_expost[i]=FDRplus_control_portfolio(.2, pi_0, Perfs[i_perf], pvalues[i_perf], FDR_port_20_expost, FDR_port_20_b_expost, &FDR_plus_20_expost, &FDR_plus_20_b_expost, &sigma_FDR_plus_20_b_expost);
		RW_port_size_expost[i]=RW_portfolio(Perfs[i_perf], Perfs_B[i_perf], RW_port_expost, &best_rule_idx_expost, &BRC_expost);
		Best_portfolio(Perfs[i_perf], best_portfolio_size_, Best_port_expost);

		nbshort_bestrule_expost+=NBshort_tmp[best_rule_idx_expost];

		//performance of rules selected ex post:
		if(i_perf==0) {
			oldproppos_FDR1_expost=lastproppos_FDR1_expost;
			oldpropneg_FDR1_expost=lastpropneg_FDR1_expost;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_1_expost, oldproppos_FDR1_expost, oldpropneg_FDR1_expost, &SR_rets_FDR_port_1_expost[R+T_fin_year_/freq], &lastproppos_FDR1_expost, &lastpropneg_FDR1_expost);
			oldproppos_FDR5_expost=lastproppos_FDR5_expost;
			oldpropneg_FDR5_expost=lastpropneg_FDR5_expost;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_5_expost, oldproppos_FDR5_expost, oldpropneg_FDR5_expost, &SR_rets_FDR_port_5_expost[R+T_fin_year_/freq], &lastproppos_FDR5_expost, &lastpropneg_FDR5_expost);
			oldproppos_FDR10_expost=lastproppos_FDR10_expost;
			oldpropneg_FDR10_expost=lastpropneg_FDR10_expost;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_10_expost, oldproppos_FDR10_expost, oldpropneg_FDR10_expost, &SR_rets_FDR_port_10_expost[R+T_fin_year_/freq], &lastproppos_FDR10_expost, &lastpropneg_FDR10_expost);
			oldproppos_FDR20_expost=lastproppos_FDR20_expost;
			oldpropneg_FDR20_expost=lastpropneg_FDR20_expost;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, FDR_port_20_expost, oldproppos_FDR20_expost, oldpropneg_FDR20_expost, &SR_rets_FDR_port_20_expost[R+T_fin_year_/freq], &lastproppos_FDR20_expost, &lastpropneg_FDR20_expost);
			oldproppos_RW_expost=lastproppos_RW_expost;
			oldpropneg_RW_expost=lastpropneg_RW_expost;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RW_port_expost, oldproppos_RW_expost, oldpropneg_RW_expost, &SR_rets_RW_port_expost[R+T_fin_year_/freq], &lastproppos_RW_expost, &lastpropneg_RW_expost);
			oldproppos_BestPort_expost=lastproppos_BestPort_expost;
			oldpropneg_BestPort_expost=lastpropneg_BestPort_expost;
			Computemu_ReturnsPorfolio_ptc_b(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, Best_port_expost, oldproppos_BestPort_expost, oldpropneg_BestPort_expost, &SR_rets_best_port_expost[R+T_fin_year_/freq], &lastproppos_BestPort_expost, &lastpropneg_BestPort_expost);

			perf_best_rule_expost+=Perfs[i_perf][best_rule_idx_expost];
			if(BRC_expost<alpha_){
				perf_BRC_expost+=Perfs[i_perf][best_rule_idx_expost];
			}
		} else if (i_perf==1) {
			oldproppos_FDR1_expost=lastproppos_FDR1_expost;
			oldpropneg_FDR1_expost=lastpropneg_FDR1_expost;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_1_expost, oldproppos_FDR1_expost, oldpropneg_FDR1_expost, &SR_rets_FDR_port_1_expost[R+T_fin_year_/freq], &lastproppos_FDR1_expost, &lastpropneg_FDR1_expost, &nbshort_tmp);
			nbshort_FDR1_expost+=nbshort_tmp;
			oldproppos_FDR5_expost=lastproppos_FDR5_expost;
			oldpropneg_FDR5_expost=lastpropneg_FDR5_expost;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_5_expost, oldproppos_FDR5_expost, oldpropneg_FDR5_expost, &SR_rets_FDR_port_5_expost[R+T_fin_year_/freq], &lastproppos_FDR5_expost, &lastpropneg_FDR5_expost, &nbshort_tmp);
			nbshort_FDR5_expost+=nbshort_tmp;
			oldproppos_FDR10_expost=lastproppos_FDR10_expost;
			oldpropneg_FDR10_expost=lastpropneg_FDR10_expost;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_10_expost, oldproppos_FDR10_expost, oldpropneg_FDR10_expost, &SR_rets_FDR_port_10_expost[R+T_fin_year_/freq], &lastproppos_FDR10_expost, &lastpropneg_FDR10_expost, &nbshort_tmp);
			nbshort_FDR10_expost+=nbshort_tmp;
			oldproppos_FDR20_expost=lastproppos_FDR20_expost;
			oldpropneg_FDR20_expost=lastpropneg_FDR20_expost;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, FDR_port_20_expost, oldproppos_FDR20_expost, oldpropneg_FDR20_expost, &SR_rets_FDR_port_20_expost[R+T_fin_year_/freq], &lastproppos_FDR20_expost, &lastpropneg_FDR20_expost, &nbshort_tmp);
			nbshort_FDR20_expost+=nbshort_tmp;
			oldproppos_RW_expost=lastproppos_RW_expost;
			oldpropneg_RW_expost=lastpropneg_RW_expost;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, RW_port_expost, oldproppos_RW_expost, oldpropneg_RW_expost, &SR_rets_RW_port_expost[R+T_fin_year_/freq], &lastproppos_RW_expost, &lastpropneg_RW_expost, &nbshort_tmp);
			nbshort_RW_expost+=nbshort_tmp;
			oldproppos_BestPort_expost=lastproppos_BestPort_expost;
			oldpropneg_BestPort_expost=lastpropneg_BestPort_expost;
			ComputeSR_ReturnsPorfolio_ptc_b_nbshort(SSS, R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, Best_port_expost, oldproppos_BestPort_expost, oldpropneg_BestPort_expost, &SR_rets_best_port_expost[R+T_fin_year_/freq], &lastproppos_BestPort_expost, &lastpropneg_BestPort_expost, &nbshort_tmp);
			nbshort_BestPort_expost+=nbshort_tmp;

			ComputeReturnsOneStrat(SSS[best_rule_idx_expost],  R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, &SR_rets_best_rule_expost[R+T_fin_year_/freq]);
			if(BRC_expost<alpha_) {
				ComputeReturnsOneStrat(SSS[best_rule_idx_expost],  R+T_fin_year_/freq, R+2*T_fin_year_/freq-1, tc, lf, DJ_Returns, RF, &SR_rets_BRC_rule_expost[R+T_fin_year_/freq]);
			} else {
				for(t=0; t<T_fin_year_; t++) {
					SR_rets_BRC_rule_expost[R+T_fin_year_/freq+t]=RF[R+T_fin_year_/freq+t];
				}
			}
		}

		//write portfolio to file:
		for(int s=0; s<nb_strats_; s++) {
			PortfoliosFile << FDR_port_10[s] << endl;
		}

		//cout << FDR_port_size_5[i] << " " << FDR_port_size_5_expost[i] << endl;

		i++;
	}

	average_FDR_plus_5_b=Average(FDR_plus_5_b,0,i-1);
	average_sigma_FDR_plus_5_b=Average(sigma_FDR_plus_5_b,0,i-1);

	average_FDR_plus_5_b_expost=Average(FDR_plus_5_b_expost,0,i-1);
	average_sigma_FDR_plus_5_b_expost=Average(sigma_FDR_plus_5_b_expost,0,i-1);

	if(i_perf==0) {
        perf_DJ=T_fin_year_*(log(DJ[R_+(1+i)*T_fin_year_/freq-1])-log(DJ[R_+T_fin_year_/freq-1]))/(i*T_fin_year_/freq);

		perf_FDR_1=MeanReturn(&SR_rets_FDR_port_1[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_5=MeanReturn(&SR_rets_FDR_port_5[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_10=MeanReturn(&SR_rets_FDR_port_10[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_20=MeanReturn(&SR_rets_FDR_port_20[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_RW=MeanReturn(&SR_rets_RW_port[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_port=MeanReturn(&SR_rets_best_port[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_rule=T_fin_year_*perf_best_rule/i;
		perf_BRC=T_fin_year_*perf_BRC/i;

		perf_FDR_1_expost=MeanReturn(&SR_rets_FDR_port_1_expost[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_5_expost=MeanReturn(&SR_rets_FDR_port_5_expost[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_10_expost=MeanReturn(&SR_rets_FDR_port_10_expost[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_20_expost=MeanReturn(&SR_rets_FDR_port_20_expost[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_RW_expost=MeanReturn(&SR_rets_RW_port_expost[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_port_expost=MeanReturn(&SR_rets_best_port_expost[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_rule_expost=T_fin_year_*perf_best_rule_expost/i;
		perf_BRC_expost=T_fin_year_*perf_BRC_expost/i;
	} else {
		perf_DJ=SharpeRatio(&DJ_Returns[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);

		perf_FDR_1=SharpeRatio(&SR_rets_FDR_port_1[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_5=SharpeRatio(&SR_rets_FDR_port_5[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_10=SharpeRatio(&SR_rets_FDR_port_10[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_20=SharpeRatio(&SR_rets_FDR_port_20[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_RW=SharpeRatio(&SR_rets_RW_port[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_port=SharpeRatio(&SR_rets_best_port[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_rule=SharpeRatio(&SR_rets_best_rule[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_BRC=SharpeRatio(&SR_rets_BRC_rule[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);

		perf_FDR_1_expost=SharpeRatio(&SR_rets_FDR_port_1_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_5_expost=SharpeRatio(&SR_rets_FDR_port_5_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_10_expost=SharpeRatio(&SR_rets_FDR_port_10_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_FDR_20_expost=SharpeRatio(&SR_rets_FDR_port_20_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_RW_expost=SharpeRatio(&SR_rets_RW_port_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_port_expost=SharpeRatio(&SR_rets_best_port_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_best_rule_expost=SharpeRatio(&SR_rets_best_rule_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
		perf_BRC_expost=SharpeRatio(&SR_rets_BRC_rule_expost[R_+T_fin_year_/freq], &RF[R_+T_fin_year_/freq], i*T_fin_year_/freq);
	}

	//for(int j=0; j<i; j++) {
	//	cout << FDR_port_size_5[j] << " " << FDR_port_size_5_expost[j] << endl;
	//}

	qsort(RW_port_size, i, sizeof(int), my_compare_int);
	int RW_q25=RW_port_size[(int)floor(.25*i)-1];
	int RW_q50=RW_port_size[(int)ceil(.5*i)-1];
	int RW_q75=RW_port_size[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_1, i, sizeof(int), my_compare_int);
	int FDR1_q25=FDR_port_size_1[(int)floor(.25*i)-1];
	int FDR1_q50=FDR_port_size_1[(int)ceil(.5*i)-1];
	int FDR1_q75=FDR_port_size_1[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_5, i, sizeof(int), my_compare_int);
	int FDR5_q25=FDR_port_size_5[(int)floor(.25*i)-1];
	int FDR5_q50=FDR_port_size_5[(int)ceil(.5*i)-1];
	int FDR5_q75=FDR_port_size_5[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_10, i, sizeof(int), my_compare_int);
	int FDR10_q25=FDR_port_size_10[(int)floor(.25*i)-1];
	int FDR10_q50=FDR_port_size_10[(int)ceil(.5*i)-1];
	int FDR10_q75=FDR_port_size_10[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_20, i, sizeof(int), my_compare_int);
	int FDR20_q25=FDR_port_size_20[(int)floor(.25*i)-1];
	int FDR20_q50=FDR_port_size_20[(int)ceil(.5*i)-1];
	int FDR20_q75=FDR_port_size_20[(int)ceil(.75*i)-1];

	qsort(RW_port_size_expost, i, sizeof(int), my_compare_int);
	int RW_q25_expost=RW_port_size_expost[(int)floor(.25*i)-1];
	int RW_q50_expost=RW_port_size_expost[(int)ceil(.5*i)-1];
	int RW_q75_expost=RW_port_size_expost[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_1_expost, i, sizeof(int), my_compare_int);
	int FDR1_q25_expost=FDR_port_size_1_expost[(int)floor(.25*i)-1];
	int FDR1_q50_expost=FDR_port_size_1_expost[(int)ceil(.5*i)-1];
	int FDR1_q75_expost=FDR_port_size_1_expost[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_5_expost, i, sizeof(int), my_compare_int);
	int FDR5_q25_expost=FDR_port_size_5_expost[(int)floor(.25*i)-1];
	int FDR5_q50_expost=FDR_port_size_5_expost[(int)ceil(.5*i)-1];
	int FDR5_q75_expost=FDR_port_size_5_expost[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_10_expost, i, sizeof(int), my_compare_int);
	int FDR10_q25_expost=FDR_port_size_10_expost[(int)floor(.25*i)-1];
	int FDR10_q50_expost=FDR_port_size_10_expost[(int)ceil(.5*i)-1];
	int FDR10_q75_expost=FDR_port_size_10_expost[(int)ceil(.75*i)-1];
	qsort(FDR_port_size_20_expost, i, sizeof(int), my_compare_int);
	int FDR20_q25_expost=FDR_port_size_20_expost[(int)floor(.25*i)-1];
	int FDR20_q50_expost=FDR_port_size_20_expost[(int)ceil(.5*i)-1];
	int FDR20_q75_expost=FDR_port_size_20_expost[(int)ceil(.75*i)-1];


	//Writing Output to Files +++++++++++++++++++++++++++++++++++++++++++++++
	ResultsFile << B_ << endl;
	ResultsFile << perf_FDR_1 << endl;
	ResultsFile << perf_FDR_5 << endl;
	ResultsFile << perf_FDR_10 << endl;
	ResultsFile << perf_FDR_20 << endl;
	ResultsFile << perf_RW << endl;
	ResultsFile << perf_best_port << endl;
	ResultsFile << perf_best_rule << endl;
	ResultsFile << perf_BRC << endl;
	ResultsFile << perf_DJ << endl;

	ResultsFile << perf_FDR_1_expost << endl;
	ResultsFile << perf_FDR_5_expost << endl;
	ResultsFile << perf_FDR_10_expost << endl;
	ResultsFile << perf_FDR_20_expost << endl;
	ResultsFile << perf_RW_expost << endl;
	ResultsFile << perf_best_port_expost << endl;
	ResultsFile << perf_best_rule_expost << endl;
	ResultsFile << perf_BRC_expost << endl;

	ResultsFile << FDR1_q25 << endl;
	ResultsFile << FDR1_q50 << endl;
	ResultsFile << FDR1_q75 << endl;
	ResultsFile << FDR5_q25 << endl;
	ResultsFile << FDR5_q50 << endl;
	ResultsFile << FDR5_q75 << endl;
	ResultsFile << FDR10_q25 << endl;
	ResultsFile << FDR10_q50 << endl;
	ResultsFile << FDR10_q75 << endl;
	ResultsFile << FDR20_q25 << endl;
	ResultsFile << FDR20_q50 << endl;
	ResultsFile << FDR20_q75 << endl;
	ResultsFile << RW_q25 << endl;
	ResultsFile << RW_q50 << endl;
	ResultsFile << RW_q75 << endl;

	ResultsFile << FDR1_q25_expost << endl;
	ResultsFile << FDR1_q50_expost << endl;
	ResultsFile << FDR1_q75_expost << endl;
	ResultsFile << FDR5_q25_expost << endl;
	ResultsFile << FDR5_q50_expost << endl;
	ResultsFile << FDR5_q75_expost << endl;
	ResultsFile << FDR10_q25_expost << endl;
	ResultsFile << FDR10_q50_expost << endl;
	ResultsFile << FDR10_q75_expost << endl;
	ResultsFile << FDR20_q25_expost << endl;
	ResultsFile << FDR20_q50_expost << endl;
	ResultsFile << FDR20_q75_expost << endl;
	ResultsFile << RW_q25_expost << endl;
	ResultsFile << RW_q50_expost << endl;
	ResultsFile << RW_q75_expost << endl;

	ResultsFile << average_FDR_plus_5_b << endl;
	ResultsFile << average_sigma_FDR_plus_5_b << endl;

	ResultsFile << average_FDR_plus_5_b_expost << endl;
	ResultsFile << average_sigma_FDR_plus_5_b_expost << endl;

	ResultsFile << nbshort_FDR10/(i*T_fin_year_/freq) << endl;
	ResultsFile << nbshort_RW/(i*T_fin_year_/freq) << endl;
	ResultsFile << nbshort_BestPort/(i*T_fin_year_/freq) << endl;
	ResultsFile << nbshort_bestrule/(i*T_fin_year_/freq) << endl;

	ResultsFile << nbshort_FDR10_expost/(i*T_fin_year_/freq) << endl;
	ResultsFile << nbshort_RW_expost/(i*T_fin_year_/freq) << endl;
	ResultsFile << nbshort_BestPort_expost/(i*T_fin_year_/freq) << endl;
	ResultsFile << nbshort_bestrule_expost/(i*T_fin_year_/freq) << endl;

	ResultsFile.close();
	PortfoliosFile.close();
	//SSSFile.close();
	//DJFile.close();
	//RFFile.close();

	cout << endl << "fini!!";

	//keep console open when using visual studio
	string fin;
	getline(cin, fin);
	
	//return 0;
	
}
	
	
	




