#include <cmath>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include "Umgebung.h"
#include "Tools.h"

using namespace std;

double Diffs[B_][nb_strats_];
double Maxs[B_];

//extern strat_struct my_table[nb_strats_];

int RW_portfolio(double Perfs[], double Perfs_B[][nb_strats_], int Portfolio[], int * best_rule_idx, double * BRC) {

	int s, olds, b;
	double c, best_perf;
	double BRC_tmp;
	strat_struct my_table[nb_strats_];

	for(s=0; s<nb_strats_; s++) {
		Portfolio[s]=0;
	}

	for(b=0; b<B_; b++) {
        for(s=0; s<nb_strats_; s++) {		
			Diffs[b][s]=Perfs_B[b][s]-Perfs[s];
		}
	}

	for(s=0; s<nb_strats_; s++) {
		my_table[s].idx=s;
		my_table[s].perf=Perfs[s];
        my_table[s].pvalue=10;
	}
	qsort(my_table, nb_strats_, sizeof(strat_struct), my_compare_strat_struct_perf_dec);

	//Romano Wolf / BRC
	*best_rule_idx=my_table[0].idx;
	best_perf=my_table[0].perf;

	//BRC
	BRC_tmp=0;
	for(b=0; b<B_; b++) {
		Maxs[b]=FindHigh(Diffs[b], 0, nb_strats_-1);
		if(best_perf<Maxs[b]) {
			BRC_tmp++;
		}
	}
	*BRC=BRC_tmp/B_;
	//end BRC

	olds=-1;
	s=0;
	while(s>olds && s<nb_strats_) {
		olds=s;
		for(b=0; b<B_; b++) {
            Maxs[b]=FindHigh(Diffs[b], s, nb_strats_-1);
		}

		qsort(Maxs, B_, sizeof(double), my_compare_double);
		c=Maxs[(int)floor((1-alpha_)*B_)-1];

		while(my_table[s].perf-c>0 && s<nb_strats_) {
			Portfolio[my_table[s].idx]=1;
			s++;
		}
	}
	return s;
}


