#include "Tools.h"

int SupportResistance1(int oldS, long t, long * pt_holding_period, int n, double b, int c, double * Prices) {
//first defintion of extrema, constant holding period, percentage band filter
	int S;
	if((t-*pt_holding_period)<c)
  		S=oldS;
	else {
		double max=FindHigh(Prices, t-n, t-1);
		double min=FindLow(Prices, t-n, t-1);
		if(Prices[t]>(1+b)*max) {
			S=1;
			*pt_holding_period=t;
		} else if(Prices[t]<(1-b)*min) {
            S=-1;
			*pt_holding_period=t;
		} else
			S=0;
			//S=oldS;
	}
	return S;
}

int SupportResistance2(int oldS, long t, long * pt_holding_period, int n, int d, int c, double * Prices) {
//first def of extrema, constant holding period, time delay filter
	int S;
	if((t-*pt_holding_period)<c)
  		S=oldS;
	else {
		S=1;
		int i=0;
		double max;
		double min;
		while(i<d && S!=0){
			max=FindHigh(Prices, t-n-i, t-1-i);
			min=FindLow(Prices, t-n-i, t-1-i);
			// if(i==0 && Prices[t]>max)
				// S=1;
			if(i==0 && Prices[t]<min)
				S=-1;
			else if((Prices[t-i]>min && S==-1) || (Prices[t-i]<max && S==1))
				S=0;
			i++;
		}
		if(S!=0)
			*pt_holding_period=t;
	}
	return S;
}

int SupportResistance1b(int oldS, long t, long * pt_extrema, long * pt_holding_period, int e, double b, int c, double * Prices) {
//alternative defintion of extrema, constant holding period, percentage band filter
	int S;
	if((t-*pt_holding_period)<c)
  		S=oldS;
	else {
		double max=FindHigh2(Prices, *pt_extrema, t-1, e);
		double min=FindLow2(Prices, *pt_extrema, t-1, e);
		if(max!=-1 && Prices[t]>(1+b)*max) {
			S=1;
			*pt_holding_period=t;
			*pt_extrema=t+c-1;
		} else if(min!=-1 && Prices[t]<(1-b)*min) {
            S=-1;
			*pt_holding_period=t;
			*pt_extrema=t+c-1;
		} else
			S=0;
			//S=oldS;
	}
	return S;
}

int SupportResistance2b(int oldS, long t, long * pt_extrema, long * pt_holding_period, int e, int d, int c, double * Prices) {
//alternative def of extrema, constant holding period, time delay filter
	int S;
	if((t-*pt_holding_period)<c)
  		S=oldS;
	else {
		S=1;
		int i=0;
		double max;
		double min;
		while(i<d && S!=0){
			max=FindHigh2(Prices, *pt_extrema, t-1-i, e);
			min=FindLow2(Prices, *pt_extrema, t-1-i, e);
			if(min==-1 && max==-1)
				S=0;
			if(i==0 && max!=-1 && Prices[t]>max)
				S=1;
			else if(i==0 && min!=-1 && Prices[t]<min)
				S=-1;
			else if((S==1 && max==-1) || (S==-1 && min==-1) || (min!=-1 && Prices[t-i]>min && S==-1) || (max!=-1 && Prices[t-i]<max && S==1))
				S=0;
			i++;
		}
		if(S!=0) {
			*pt_holding_period=t;
			*pt_extrema=t+c-1;
		}
	}
	return S;
}

