#include <cstdlib>
#include <cmath>

#include <direct.h>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include <algorithm>
#include <vector>

#include "Umgebung.h"

#include "Tools.h"
#include "FDR_tools.h"
#include "FDR_portfolio.h"
#include "Rom_Wolf_portfolio.h"
#include "Strategies.h"
#include "Perf_tools.h"
#include "Infos.h"

using namespace std;

double RF_bis_test[N_];
double SR_ReturnsPorfolio_test[N_];

double DJ[TT_];
double RF[TT_];
double DJ_Returns[TT_];
double OBVI[TT_];
int SLOW[nb_strats_];
int NBER[TT_];
long IDX[B_][N_];

double Perfs[nb_perf_measures_][nb_strats_];
double Perfs_B[nb_perf_measures_][B_][nb_strats_];

int SSS[nb_strats_][N_];

double ReturnsPorfolio[N_];
double ReturnsPorfolio_RW[N_];

strat_struct my_table[nb_strats_];

double pvalues[nb_perf_measures_][nb_strats_];

int FDRplus_5_port[nb_strats_];
int FDRplus_5_port_2[nb_strats_];
int FDRminus_5_port[nb_strats_];
int FDRminus_5_port_2[nb_strats_];
int FDRplus_10_port[nb_strats_];
int FDRplus_10_port_2[nb_strats_];
int FDRminus_10_port[nb_strats_];
int FDRminus_10_port_2[nb_strats_];
int FDRexplo_port[nb_strats_];
int RW_port[nb_strats_];
int Best_port[nb_strats_];

int FDRplus_5_nbrules_bycateg[5];
int FDRplus_10_nbrules_bycateg[5];
int FDRexplo_nbrules_bycateg[5];

int FDRplus_5_nbrules_byhori[2];
int FDRplus_10_nbrules_byhori[2];
int FDRexplo_nbrules_byhori[2];

long NB_trades[nb_strats_];

infos_struct ALL_Infos[nb_strats_];
infos_struct FDRplus_5_port_Infos;
infos_struct FDRplus_10_port_Infos;
infos_struct FDRexplo_port_Infos;
infos_struct RW_port_Infos;
infos_struct Best_port_Infos;


template <class T>
void to_string(string & result, const T & t) {
	ostringstream oss; // create a stream
	oss << t; // insert value to stream
	result=oss.str(); // extract value and write it to result
}

int main() {

	int s, i_TC, i_perf;
	long t;

	double W, Rplus, Fplus, Rminus, Fminus, FDRplus_explo, FDRminus_explo;
	double FDRplus_5, FDRplus_5_2, FDRplus_10, FDRplus_10_2;
	double FDRminus_5, FDRminus_5_2, FDRminus_10, FDRminus_10_2;
	int FDRplus_5_portsize, FDRminus_5_portsize, FDRplus_10_portsize, FDRminus_10_portsize;
	int FDRexplo_portsize, RW_portsize;
	double sigma_FDRplus_explo, sigma_FDRplus_5_2, sigma_FDRplus_10_2;
	double pi_0;
	double pi_A_plus_035, pi_A_plus_040, pi_A_plus_045;
	double pi_A_minus_035, pi_A_minus_040, pi_A_minus_045;
	double sigma_pi_A_plus_035, sigma_pi_A_plus_040, sigma_pi_A_plus_045;
	double sigma_pi_A_minus_035, sigma_pi_A_minus_040, sigma_pi_A_minus_045;

	double perf_FDRplus_5=0;
	double perf_FDRplus_10=0;
	double perf_FDRexplo=0;
	double perf_RW=0;
	double perf_Bestport=0;
	double perf_Bestrule=0;

	double mu_FDRplus_5=0;
	double mu_FDRplus_10=0;
	double mu_FDRexplo=0;
	double mu_RW=0;
	double mu_Bestport=0;
	double mu_Bestrule=0;

	double nbtransac_FDR10_SR, nbtransac_RW_SR;

	int bestrule_idx;
	double BRC;

	string resultats_path, resultats_path_2, file_path;
	ofstream ResultsFile, Results2File, NB_tradesFiles, pvaluesFile, PerfsFile, 
		FDRplus_5_portFile, FDRminus_5_portFile, FDRplus_10_portFile, FDRminus_10_portFile,
		FDRexplo_portFile, RW_portFile, ReturnsPorfolioFile;
	//ofstream Perfs_BFile;
	string tmp;

	//resultats_path_2=boulot_path_+"\\DATA\\dataprojet1\\resultats";
	resultats_path_2=boulot_path_+"\\DATA\\dataprojet1\\resultats_post20110716";
	_mkdir(resultats_path_2.c_str());
	resultats_path_2=resultats_path_2+"\\strats";
	_mkdir(resultats_path_2.c_str());
	to_string(tmp, strats_categ_);
	resultats_path_2=resultats_path_2+"\\strats_categ_"+tmp;
	_mkdir(resultats_path_2.c_str());
	resultats_path_2=resultats_path_2+"\\P_"+period_;
	_mkdir(resultats_path_2.c_str());

	//Begin Reading Data +++++++++++++++++++++++++++++++++++++++++++++++
	cout << "Loading data..." << endl;
	string string_DJ=boulot_path_+"\\DATA\\dataprojet1\\data\\DJ_P"+period_+".txt";
	string string_RF=boulot_path_+"\\DATA\\dataprojet1\\data\\RF_P"+period_+".txt";
	string string_OBVI=boulot_path_+"\\DATA\\dataprojet1\\data\\OBVI_P"+period_+".txt";
	string string_SLOW=boulot_path_+"\\DATA\\dataprojet1\\data\\SLOW.txt";
	string string_IDX=boulot_path_+"\\DATA\\dataprojet1\\data\\IDX_P"+period_+".txt";

	ifstream InputFile_DJ;
	ifstream InputFile_RF;
	ifstream InputFile_OBVI;
	ifstream InputFile_SLOW;
	ifstream InputFile_IDX;

	InputFile_DJ.open(string_DJ.c_str());
	InputFile_RF.open(string_RF.c_str());
	InputFile_OBVI.open(string_OBVI.c_str());
	InputFile_SLOW.open(string_SLOW.c_str());
	InputFile_IDX.open(string_IDX.c_str());

	string s_DJ;
	string s_RF;
	string s_OBVI;
	string s_SLOW;
	string s_IDX;

	for(t=0; t<TT_; t++) {
		getline(InputFile_DJ, s_DJ);
		getline(InputFile_RF, s_RF);
		getline(InputFile_OBVI, s_OBVI);
				
		DJ[t]=atof(s_DJ.c_str());
		RF[t]=atof(s_RF.c_str());
		OBVI[t]=atof(s_OBVI.c_str());
	}
	for(int b=0; b<B_; b++) {
		for(t=0; t<N_; t++) {
			getline(InputFile_IDX, s_IDX);
			IDX[b][t]=(int)atof(s_IDX.c_str());
		}
	}
	for(s=0; s<nb_strats_; s++) {
		getline(InputFile_SLOW, s_SLOW);
		SLOW[s]=(int)atof(s_SLOW.c_str());
	}

	InputFile_DJ.close();
	InputFile_RF.close();
	InputFile_OBVI.close();
	InputFile_SLOW.close();
	InputFile_IDX.close();
	//End Reading Data +++++++++++++++++++++++++++++++++++++++++++++++

	//Begin Computing Returns +++++++++++++++++++++++++++++++++++++++++++++++
	for(t=1; t<TT_; t++) {
		DJ_Returns[t]=(DJ[t]-DJ[t-1])/DJ[t-1];
	}

	for(t=0; t<TT_; t++) {
		RF[t]=log(1+RF[t]/100)/252;
	}
	//End Computing Returns +++++++++++++++++++++++++++++++++++++++++++++++

	double perf_DJ[nb_perf_measures_];
	//perf_DJ[0]=T_fin_year_*(log(DJ[T_])-log(DJ[R_-1]))/N_;
	perf_DJ[0]=T_fin_year_*Sum(&DJ_Returns[R_], N_)/N_;
	perf_DJ[1]=SharpeRatio(&DJ_Returns[R_], &RF[R_], N_);

	Strats(strats_categ_, R_, T_, SSS, DJ, OBVI);

	infos(SSS, ALL_Infos);
	Compute_nb_trades(SSS, NB_trades);

	for(i_TC=0; i_TC<nb_TC_; i_TC++) {
		cout << endl << "Bootstraping..." << endl;
		MultiPerfs(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, IDX, Perfs, pvalues, Perfs_B);
		cout << endl << "Bootstraping fini" << endl;

		for(i_perf=0; i_perf<nb_perf_measures_; i_perf++) {
			pi_0=Compute_PI_zero(pvalues[i_perf], lambda_);

			pi_A_plus_035=Compute_PI_A_plus(pvalues[i_perf], Perfs[i_perf], pi_0, .35, &sigma_pi_A_plus_035, &sigma_pi_A_minus_035);
			pi_A_plus_040=Compute_PI_A_plus(pvalues[i_perf], Perfs[i_perf], pi_0, .4, &sigma_pi_A_plus_040, &sigma_pi_A_minus_040);
			pi_A_plus_045=Compute_PI_A_plus(pvalues[i_perf], Perfs[i_perf], pi_0, .45, &sigma_pi_A_plus_045, &sigma_pi_A_minus_045);
			pi_A_minus_035=Compute_PI_A_minus(pvalues[i_perf], Perfs[i_perf], pi_0, .35);
			pi_A_minus_040=Compute_PI_A_minus(pvalues[i_perf], Perfs[i_perf], pi_0, .4);
			pi_A_minus_045=Compute_PI_A_minus(pvalues[i_perf], Perfs[i_perf], pi_0, .45);

			FDRplus_explo=FalseDiscoRate_plus(pvalues[i_perf], Perfs[i_perf], pi_0, gamma_, &W, &Rplus, &Fplus, &sigma_FDRplus_explo);
			FDRminus_explo=FalseDiscoRate_minus(pvalues[i_perf], Perfs[i_perf], pi_0, gamma_, &Rminus, &Fminus);

			FDRplus_5_portsize=FDRplus_control_portfolio(.05, pi_0, Perfs[i_perf], pvalues[i_perf], 
				FDRplus_5_port, FDRplus_5_port_2, &FDRplus_5, &FDRplus_5_2, &sigma_FDRplus_5_2);
			FDRminus_5_portsize=FDRminus_control_portfolio(.05, pi_0, Perfs[i_perf], pvalues[i_perf], 
				FDRminus_5_port, FDRminus_5_port_2, &FDRminus_5, &FDRminus_5_2);
			FDRplus_10_portsize=FDRplus_control_portfolio(.1, pi_0, Perfs[i_perf], pvalues[i_perf], 
				FDRplus_10_port, FDRplus_10_port_2, &FDRplus_10, &FDRplus_10_2, &sigma_FDRplus_10_2);
			FDRminus_10_portsize=FDRminus_control_portfolio(.1, pi_0, Perfs[i_perf], pvalues[i_perf], 
				FDRminus_10_port, FDRminus_10_port_2, &FDRminus_10, &FDRminus_10_2);
			FDRexplo_portsize=FDRexplo_portfolio(gamma_, Perfs[i_perf], pvalues[i_perf], FDRexplo_port);
			RW_portsize=RW_portfolio(Perfs[i_perf], Perfs_B[i_perf], RW_port, &bestrule_idx, &BRC);
			Best_portfolio(Perfs[i_perf], Best_portsize_, Best_port);

			port_infos(FDRplus_5_port, ALL_Infos, SSS, &FDRplus_5_port_Infos);
			port_infos(FDRplus_10_port, ALL_Infos, SSS, &FDRplus_10_port_Infos);
			port_infos(FDRexplo_port, ALL_Infos, SSS, &FDRexplo_port_Infos);
			port_infos(RW_port, ALL_Infos, SSS, &RW_port_Infos);
			port_infos(Best_port, ALL_Infos, SSS, &Best_port_Infos);

			Sort_by_categories(FDRplus_5_port, FDRplus_5_nbrules_bycateg);
			Sort_by_categories(FDRplus_10_port, FDRplus_10_nbrules_bycateg);
			Sort_by_categories(FDRexplo_port, FDRexplo_nbrules_bycateg);

			Sort_by_horizon(FDRplus_5_port, SLOW, FDRplus_5_nbrules_byhori);
			Sort_by_horizon(FDRplus_10_port, SLOW, FDRplus_10_nbrules_byhori);
			Sort_by_horizon(FDRexplo_port, SLOW, FDRexplo_nbrules_byhori);

			mu_FDRplus_5=Portfolio_mu_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, FDRplus_5_port);
			mu_FDRplus_10=Portfolio_mu_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, FDRplus_10_port);
			mu_FDRexplo=Portfolio_mu_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, FDRexplo_port);
			mu_RW=Portfolio_mu_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RW_port);
			mu_Bestport=Portfolio_mu_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, Best_port);

			if(i_perf==0) {
				perf_FDRplus_5=mu_FDRplus_5;
				perf_FDRplus_10=mu_FDRplus_10;
				perf_FDRexplo=mu_FDRexplo;
				perf_RW=mu_RW;
				perf_Bestport=mu_Bestport;

			} else if (i_perf==1) {
				//Portfolio_SR(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRplus_5_port, &perf_FDRplus_5);
				//Portfolio_SR(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRplus_10_port, &perf_FDRplus_10);
				//Portfolio_SR(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRexplo_port, &perf_FDRexplo);
				//Portfolio_SR(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, RW_port, &perf_RW);
				//Portfolio_SR(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, Best_port, &perf_Bestport);

				//pooled transaction costs:
				//ComputeSR_ReturnsPorfolio_ptc_b(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRplus_10_port, 0, 0, SR_rets_FDR_port_10, &lastproppos, &lastpropneg);

				//double lastproppos, lastpropneg;
				////ComputeSR_ReturnsPorfolio_ptc_b(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, RW_port, 0, 0,
				////					 SR_ReturnsPorfolio_test, &lastproppos, &lastpropneg, RF_bis_test);
				//ComputeSR_ReturnsPorfolio_ptc_b_test(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, RW_port, 0, 0,
				//					 SR_ReturnsPorfolio_test, &lastproppos, &lastpropneg, RF_bis_test);
				//string portFile_path=boulot_path_+"\\DATA\\dataprojet1\\resultats\\retport.txt";
				//string rfFile_path=boulot_path_+"\\DATA\\dataprojet1\\resultats\\retrf.txt";
				//ofstream portRetsFile, rfRetsFile;
				//portRetsFile.open(portFile_path.c_str(), ofstream::out | ofstream::trunc);
				//rfRetsFile.open(rfFile_path.c_str(), ofstream::out | ofstream::trunc);
				//for(t=0; t<N_; t++) {
				//	portRetsFile << SR_ReturnsPorfolio_test[t] << endl;
				//	rfRetsFile << RF_bis_test[t] << endl;
				//}
				//portRetsFile.close();
				//rfRetsFile.close();

				perf_FDRplus_5=Portfolio_SR_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRplus_5_port);
				perf_FDRplus_10=Portfolio_SR_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRplus_10_port);
				perf_FDRexplo=Portfolio_SR_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, FDRexplo_port);
				perf_RW=Portfolio_SR_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, RW_port);
				perf_Bestport=Portfolio_SR_ptc(SSS, R_, T_, TC_[i_TC], LF_[i_TC], DJ_Returns, RF, Best_port);

				nbtransac_FDR10_SR=ComputeSR_nbporttransacs(SSS, R_, T_, FDRplus_10_port);
				nbtransac_RW_SR=ComputeSR_nbporttransacs(SSS, R_, T_, RW_port);
			}
			mu_Bestrule=Perfs[0][bestrule_idx];
			perf_Bestrule=Perfs[i_perf][bestrule_idx];

			if(i_perf==0) {
				perf_FDRplus_5*=T_fin_year_;
				perf_FDRplus_10*=T_fin_year_;
				perf_FDRexplo*=T_fin_year_;
				perf_RW*=T_fin_year_;
				perf_Bestport*=T_fin_year_;
				perf_Bestrule*=T_fin_year_;
			}

			//Writing Output to Files +++++++++++++++++++++++++++++++++++++++++++++++
			cout << endl << "Writing output to files..." << endl;
			resultats_path=resultats_path_2+"\\"+tc_lf_paths_[i_TC];
			_mkdir(resultats_path.c_str());

			if(i_perf==0) {
				tmp="mu";
			} else if (i_perf==1) {
				tmp="SR";
			}
			file_path=resultats_path+"\\Results_"+tmp+".txt";
			ResultsFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\Results2_"+tmp+".txt";
			Results2File.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\NB_trades_"+tmp+".txt";
			NB_tradesFiles.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\pvalues_"+tmp+".txt";
			pvaluesFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\Perfs_"+tmp+".txt";
			PerfsFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			//file_path=resultats_path+"\\Perfs_B_"+tmp+".txt";
			//Perfs_BFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\FDRplus_5_port_"+tmp+".txt";
			FDRplus_5_portFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\FDRplus_10_port_"+tmp+".txt";
			FDRplus_10_portFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\FDRexplo_port_"+tmp+".txt";
			FDRexplo_portFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\RW_port_"+tmp+".txt";
			RW_portFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			file_path=resultats_path+"\\ReturnsPorfolio_"+tmp+".txt";
			ReturnsPorfolioFile.open(file_path.c_str(), ofstream::out | ofstream::trunc);
			
			ResultsFile << B_;
			ResultsFile << endl << TC_[i_TC];
			ResultsFile << endl << LF_[i_TC];
			ResultsFile << endl << BRC;
			ResultsFile << endl << bestrule_idx;
			ResultsFile << endl << pi_0;
			ResultsFile << endl << pi_A_plus_035;
			ResultsFile << endl << pi_A_plus_040;
			ResultsFile << endl << pi_A_plus_045;
			ResultsFile << endl << pi_A_minus_035;
			ResultsFile << endl << pi_A_minus_040;
			ResultsFile << endl << pi_A_minus_045;

			ResultsFile << endl << FDRplus_5;
			ResultsFile << endl << FDRplus_5_2;
			ResultsFile << endl << FDRminus_5;
			ResultsFile << endl << FDRminus_5_2;
			ResultsFile << endl << FDRplus_10;
			ResultsFile << endl << FDRplus_10_2;
			ResultsFile << endl << FDRminus_10;
			ResultsFile << endl << FDRminus_10_2;
			ResultsFile << endl << FDRplus_explo;
			ResultsFile << endl << FDRminus_explo;
			
			ResultsFile << endl << perf_FDRplus_5;
			ResultsFile << endl << perf_FDRplus_10;
			ResultsFile << endl << perf_FDRexplo;
			ResultsFile << endl << perf_RW;
			ResultsFile << endl << perf_Bestport;
			ResultsFile << endl << perf_Bestrule;
			ResultsFile << endl << perf_DJ[i_perf];

			ResultsFile << endl << mu_FDRplus_5*N_;
			ResultsFile << endl << mu_FDRplus_10*N_;
			ResultsFile << endl << mu_FDRexplo*N_;
			ResultsFile << endl << mu_RW*N_;
			ResultsFile << endl << mu_Bestport*N_;
			ResultsFile << endl << mu_Bestrule*N_;

			ResultsFile << endl << FDRplus_5_portsize;
			ResultsFile << endl << FDRminus_5_portsize;
			ResultsFile << endl << FDRplus_10_portsize;
			ResultsFile << endl << FDRminus_10_portsize;
			ResultsFile << endl << FDRexplo_portsize;
			ResultsFile << endl << RW_portsize;

			ResultsFile << endl << Rplus;
			ResultsFile << endl << Rminus;
			ResultsFile << endl << Fplus;
			ResultsFile << endl << Fminus;
			
			ResultsFile << endl << sigma_FDRplus_explo;
			ResultsFile << endl << sigma_FDRplus_5_2;
			ResultsFile << endl << sigma_FDRplus_10_2;
			ResultsFile << endl << sigma_pi_A_plus_035;
			ResultsFile << endl << sigma_pi_A_plus_040;
			ResultsFile << endl << sigma_pi_A_plus_045;
			ResultsFile << endl << sigma_pi_A_minus_035;
			ResultsFile << endl << sigma_pi_A_minus_040;
			ResultsFile << endl << sigma_pi_A_minus_045;

			ResultsFile << endl << mu_FDRplus_10*N_/nbtransac_FDR10_SR;
			ResultsFile << endl << mu_RW*N_/nbtransac_RW_SR;

			ResultsFile << endl;

			Results2File << B_;
			Results2File << endl << TC_[i_TC];
			Results2File << endl << LF_[i_TC];
			Results2File << endl << FDRplus_5_nbrules_bycateg[0];
			Results2File << endl << FDRplus_5_nbrules_bycateg[1];
			Results2File << endl << FDRplus_5_nbrules_bycateg[2];
			Results2File << endl << FDRplus_5_nbrules_bycateg[3];
			Results2File << endl << FDRplus_5_nbrules_bycateg[4];
			Results2File << endl << FDRplus_5_nbrules_byhori[0];
			Results2File << endl << FDRplus_5_nbrules_byhori[1];

			Results2File << endl << FDRplus_10_nbrules_bycateg[0];
			Results2File << endl << FDRplus_10_nbrules_bycateg[1];
			Results2File << endl << FDRplus_10_nbrules_bycateg[2];
			Results2File << endl << FDRplus_10_nbrules_bycateg[3];
			Results2File << endl << FDRplus_10_nbrules_bycateg[4];
			Results2File << endl << FDRplus_10_nbrules_byhori[0];
			Results2File << endl << FDRplus_10_nbrules_byhori[1];

			Results2File << endl << FDRexplo_nbrules_bycateg[0];
			Results2File << endl << FDRexplo_nbrules_bycateg[1];
			Results2File << endl << FDRexplo_nbrules_bycateg[2];
			Results2File << endl << FDRexplo_nbrules_bycateg[3];
			Results2File << endl << FDRexplo_nbrules_bycateg[4];
			Results2File << endl << FDRexplo_nbrules_byhori[0];
			Results2File << endl << FDRexplo_nbrules_byhori[1];
			Results2File << endl;

			file_path=resultats_path+"\\FDRplus_5_port_Infos_"+tmp+".txt";
			PrintInfos(file_path, FDRplus_5_port_Infos);
			file_path=resultats_path+"\\FDRplus_10_port_Infos_"+tmp+".txt";
			PrintInfos(file_path, FDRplus_10_port_Infos);
			file_path=resultats_path+"\\FDRexplo_port_Infos_"+tmp+".txt";
			PrintInfos(file_path, FDRexplo_port_Infos);
			file_path=resultats_path+"\\RW_port_Infos_"+tmp+".txt";
			PrintInfos(file_path, RW_port_Infos);
			file_path=resultats_path+"\\Best_port_Infos_"+tmp+".txt";
			PrintInfos(file_path, Best_port_Infos);
			file_path=resultats_path+"\\Best_rule_Infos_"+tmp+".txt";
			PrintInfos(file_path, ALL_Infos[bestrule_idx]);

			for(s=0; s<nb_strats_; s++) {
				//NB_tradesFiles << NB_trades[s]/(N_/252) << endl;
				NB_tradesFiles << NB_trades[s] << endl;
				pvaluesFile << pvalues[i_perf][s] << endl;
				PerfsFile << Perfs[i_perf][s] << endl;
				FDRplus_5_portFile << FDRplus_5_port[s] << endl;
				FDRplus_10_portFile << FDRplus_10_port[s] << endl;
				FDRexplo_portFile << FDRexplo_port[s] << endl;
				RW_portFile << RW_port[s] << endl;
			}

			//for(int b=0; b<B_; b++) {
			//	for(s=0; s<nb_strats_; s++) {
			//		Perfs_BFile << Perfs_B[i_perf][b][s] << endl;
			//	}
			//}

			for(t=0; t<N_; t++) {
				ReturnsPorfolioFile << ReturnsPorfolio[t] << endl;
			}

			ResultsFile.close();
			Results2File.close();
			NB_tradesFiles.close();
			pvaluesFile.close();
			PerfsFile.close();
			//Perfs_BFile.close();
			FDRplus_5_portFile.close();
			FDRplus_10_portFile.close();
			FDRexplo_portFile.close();
			RW_portFile.close();
			ReturnsPorfolioFile.close();
		}
	}

	cout << endl << "fini!!";

	//keep console open when using visual studio
	string fin;
	getline(cin, fin);
	
	//return 0;
	
}
	
	
	




