#include <cmath>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include "Umgebung.h"

using namespace std;

int my_compare_int(const void *a, const void *b) {
    if(*(int*)a > *(int*)b) return 1;
    if(*(int*)a < *(int*)b) return -1;
    return 0;
}

int my_compare_double(const void *a, const void *b) {
    if(*(double*)a > *(double*)b) return 1;
    if(*(double*)a < *(double*)b) return -1;
    return 0;
}

//would be better to use STL !!!
int my_compare_strat_struct_pvalue(const void *a, const void *b) {
    strat_struct *aa=(strat_struct *)a;
    strat_struct *bb=(strat_struct *)b;    
    if(aa->pvalue > bb->pvalue) return 1;
    if(aa->pvalue < bb->pvalue) return -1;
    return 0;
}

//attention: du plus grand au plus petit (decreasing)
int my_compare_strat_struct_perf_dec(const void *a, const void *b) {
    strat_struct *aa=(strat_struct *)a;
    strat_struct *bb=(strat_struct *)b;    
    if(aa->perf < bb->perf) return 1;
    if(aa->perf > bb->perf) return -1;
    return 0;
}

//increasing
int my_compare_strat_struct_perf_inc(const void *a, const void *b) {
    strat_struct *aa=(strat_struct *)a;
    strat_struct *bb=(strat_struct *)b;    
    if(aa->perf > bb->perf) return 1;
    if(aa->perf < bb->perf) return -1;
    return 0;
}

double Sum(double Array[], long n) {
	double total=0;
	for(long t=0; t<n; t++)
		total+=Array[t];
	return total;
}

long Sum(int Array[], long n) {
	long total=0;
	for(long t=0; t<n; t++)
		total+=Array[t];
	return total;
}

double Sum(double Array[], long a, long b) {
	double total=0;
	for(long t=a; t<=b; t++)
		total+=Array[t];
	return total;
}

double Average(double Array[], long t_begin, long t_end) {
	double mu=0;
	for(long t=t_begin; t<=t_end; t++)
		mu+=Array[t];
	return mu/(t_end-t_begin+1);
}

double FindHigh(double Prices[], long t_begin, long t_end) {
	double high=Prices[t_begin];
	for(long t=t_begin+1; t<=t_end; t++) {
		if(Prices[t]>high) {
			high=Prices[t];
		}
	}
	return high;
}

double FindLow(double Prices[], long t_begin, long t_end) {
	double low=Prices[t_begin];
	for(long t=t_begin+1; t<=t_end; t++) {
		if(Prices[t]<low) {
			low=Prices[t];
		}
	}
	return low;
}

//alternative definition of extrema:
double FindHigh2(double Prices[], long t_begin, long t_end, int e) {
	double high;
	int flag=0;
	long t=0;
	int i;
	while(flag==0 && t_begin<=(t_end-t-e)) {
		flag=1;
		high=Prices[t_end-t];
		i=1;
		while(i<=e && flag==1) {
			if(high<Prices[t_end-t-i])
				flag=0;
			i++;
		}
		t++;
	}
	if(flag==1)
		return high;
	else
		return -1; //if t_begin crossed
}

double FindLow2(double Prices[], long t_begin, long t_end, int e) {
	double low;
	int flag=0;
	long t=0;
	int i;
	while(flag==0 && t_begin<=(t_end-t-e)) {
		flag=1;
		low=Prices[t_end-t];
		i=1;
		while(i<=e && flag==1) {
			if(low>Prices[t_end-t-i])
				flag=0;
			i++;
		}
		t++;
	}
	if(flag==1)
		return low;
	else
		return -1; //if t_begin crossed
}


void DispProgress(long count) {
	if((count%10)==0)
		cout << ".";
}


void PrintInfos(string filename, infos_struct Infos) {

	ofstream outputfile;
	outputfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

	outputfile << B_;
	outputfile << endl << Infos.nb_trades;
	outputfile << endl << Infos.nb_w_trades;
	outputfile << endl << Infos.nb_l_trades;
	outputfile << endl << Infos.nb_days_per_trade;
	outputfile << endl << Infos.nb_days_per_w_trade;
	outputfile << endl << Infos.nb_days_per_l_trade;
	outputfile << endl << Infos.return_per_trade;
	outputfile << endl << Infos.return_per_w_trade;
	outputfile << endl << Infos.return_per_l_trade;
				
	outputfile << endl << Infos.nb_trades_L;
	outputfile << endl << Infos.nb_w_trades_L;
	outputfile << endl << Infos.nb_l_trades_L;
	outputfile << endl << Infos.nb_days_per_trade_L;
	outputfile << endl << Infos.nb_days_per_w_trade_L;
	outputfile << endl << Infos.nb_days_per_l_trade_L;
	outputfile << endl << Infos.return_per_trade_L;
	outputfile << endl << Infos.return_per_w_trade_L;
	outputfile << endl << Infos.return_per_l_trade_L;
				
	outputfile << endl << Infos.nb_trades_S;
	outputfile << endl << Infos.nb_w_trades_S;
	outputfile << endl << Infos.nb_l_trades_S;
	outputfile << endl << Infos.nb_days_per_trade_S;
	outputfile << endl << Infos.nb_days_per_w_trade_S;
	outputfile << endl << Infos.nb_days_per_l_trade_S;
	outputfile << endl << Infos.return_per_trade_S;
	outputfile << endl << Infos.return_per_w_trade_S;
	outputfile << endl << Infos.return_per_l_trade_S;

	outputfile << endl << Infos.nb_transacs;

	outputfile << endl << Infos.prop_winning_signals;
	outputfile << endl << Infos.prop_neutral_signals;
	outputfile << endl << Infos.prop_losing_signals;

	outputfile << endl;

	outputfile.close();
}



