#include <cmath>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include "Umgebung.h"

#include "Tools.h"
#include "FDR_tools.h"

using namespace std;

//strat_struct my_table[nb_strats_];


int FDRplus_control_portfolio(double FDR_target, double pi_0, double Perfs[], double pvalues[], 
								 int Portfolio[], int Portfolio_2[], double * actual_FDR, 
								 double * actual_FDR_2, double * sigma_actual_FDR_2) {
	int s;
	strat_struct my_table[nb_strats_];

	for(s=0; s<nb_strats_; s++) {
		Portfolio[s]=0;
	}

	double W, R, F, gamma, FDR, sigma_FDR, old_FDR;
	
	for(s=0; s<nb_strats_; s++) {
		my_table[s].idx=s;
		my_table[s].perf=Perfs[s];
		if(Perfs[s]>0) {
            my_table[s].pvalue=pvalues[s];
		} else {
			my_table[s].pvalue=2; //technique...
		}
	}
	//qsort seems stable...
	qsort(my_table, nb_strats_, sizeof(strat_struct), my_compare_strat_struct_perf_dec);
	qsort(my_table, nb_strats_, sizeof(strat_struct), my_compare_strat_struct_pvalue);

	s=0;
	gamma=my_table[s].pvalue;
	old_FDR=-1;
	FDR=FalseDiscoRate_plus(pvalues, Perfs, pi_0, gamma, &W, &R, &F, &sigma_FDR);
	//while(FDR_plus<myFDR && s<best_portfolio_size_ && my_table[s].pvalue<2) {
	while(FDR<FDR_target && my_table[s].pvalue<2 && s<nb_strats_) {
		Portfolio[my_table[s].idx]=1;
		Portfolio_2[my_table[s].idx]=1;
		s++;
		gamma=my_table[s].pvalue;
		old_FDR=FDR;
		FDR=FalseDiscoRate_plus(pvalues, Perfs, pi_0, gamma, &W, &R, &F, &sigma_FDR);
	}

	Portfolio_2[my_table[s].idx]=1;
	*actual_FDR=old_FDR;
	*actual_FDR_2=FDR;
	*sigma_actual_FDR_2=sigma_FDR;

	return s;
}

int FDRminus_control_portfolio(double FDR_target, double pi_0, double Perfs[], double pvalues[], 
								 int Portfolio[], int Portfolio_2[], double * actual_FDR, 
								 double * actual_FDR_2) {
	int s;
	strat_struct my_table[nb_strats_];

	for(s=0; s<nb_strats_; s++) {
		Portfolio[s]=0;
	}

	double R, F, gamma, FDR, old_FDR;
	
	for(s=0; s<nb_strats_; s++) {
		my_table[s].idx=s;
		my_table[s].perf=Perfs[s];
		if(Perfs[s]<0) {
            my_table[s].pvalue=pvalues[s];
		} else {
			my_table[s].pvalue=2; //technique...
		}
	}
	//qsort seems stable...
	qsort(my_table, nb_strats_, sizeof(strat_struct), my_compare_strat_struct_perf_inc);
	qsort(my_table, nb_strats_, sizeof(strat_struct), my_compare_strat_struct_pvalue);

	s=0;
	gamma=my_table[s].pvalue;
	old_FDR=-1;
	FDR=FalseDiscoRate_minus(pvalues, Perfs, pi_0, gamma, &R, &F);
	//while(FDR_plus<myFDR && s<best_portfolio_size_ && my_table[s].pvalue<2) {
	while(FDR<FDR_target && my_table[s].pvalue<2 && s<nb_strats_) {
		Portfolio[my_table[s].idx]=1;
		Portfolio_2[my_table[s].idx]=1;
		s++;
		gamma=my_table[s].pvalue;
		old_FDR=FDR;
		FDR=FalseDiscoRate_minus(pvalues, Perfs, pi_0, gamma, &R, &F);
	}

	Portfolio_2[my_table[s].idx]=1;
	*actual_FDR=old_FDR;
	*actual_FDR_2=FDR;

	return s;
}



int FDRexplo_portfolio(double mypvalue, double Perfs[], double pvalues[], int Portfolio[]) {

	int s;
	int port_size=0;

	for(s=0; s<nb_strats_; s++) {
		Portfolio[s]=0;
	}
	
	for(s=0; s<nb_strats_; s++) {
		if(pvalues[s]<=mypvalue && Perfs[s]>0) {
			port_size++;
			Portfolio[s]=1;
		}
	}

	return port_size;

}


