#include <cmath>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include "Umgebung.h"

using namespace std;

double Compute_PI_zero(double pvalues[], double lambda) {
	double W=0;
	double nb_null_pvalues=0;
	double pi_0;

	for(long s=0; s<nb_strats_; s++) {
		if(pvalues[s]>lambda) {
			W++;
		}
		if(pvalues[s]==-1) {
			nb_null_pvalues++;
		}
	}
	pi_0=( W+nb_null_pvalues*(1-lambda) )/( (1-lambda)*nb_strats_ );
	return (pi_0<1) ? pi_0 : 1;

}

double Compute_PI_zero(double pvalues[], double lambda, long NB_trades[]) {
	double W=0;
	double nb_null_pvalues=0;
	double pi_0;

	for(long s=0; s<nb_strats_; s++) {
		if((pvalues[s]>lambda) && (NB_trades[s]>5)) {
			W++;
		}
		if((pvalues[s]==-1) || (NB_trades[s]<=5)) {
			nb_null_pvalues++;
		}
	}
	pi_0=( W+nb_null_pvalues*(1-lambda) )/( (1-lambda)*nb_strats_ );
	return (pi_0<1) ? pi_0 : 1;

}

double FalseDiscoRate(double pvalues[], double pi_0, double gamma, double * R, double * F) {
	double FF;
	double RR=0;
	
	for(long s=0; s<nb_strats_; s++) {
		if((pvalues[s]<=gamma) && (pvalues[s]!=-1)) {
			RR++;
		}
	}
	*R=RR;

	if(RR>0) {
        FF=nb_strats_*pi_0*gamma;
		if(FF>RR) {
            FF=RR;
		}
		*F=ceil(FF);
		return FF/RR;
	} else {
		*F=0;
		return 2;
	}

}

double FalseDiscoRate_plus(double pvalues[], double Perfs[], double pi_0, double gamma, double * W, double * R_plus, double * F_plus, double * sigma_FDR_plus) {
	double FF_plus;
	double RR_plus=0;
	double WW=0;
	double nb_null_pvalues=0;

	long s;

	for(s=0; s<nb_strats_; s++) {
		if(pvalues[s]>gamma) {
			WW++;
		}
		if(pvalues[s]==-1) {
			nb_null_pvalues++;
		}
		if((pvalues[s]<=gamma) && (Perfs[s]>0)) {
		//superflu:
		//if((pvalues[s]<=gamma) && (pvalues[s]!=-1) && (Perfs[s]>0)) {
			RR_plus++;
		}
	}
	WW+=nb_null_pvalues*(1-gamma);
	*W=WW;
	*R_plus=RR_plus;

	*sigma_FDR_plus=sqrt( pow((gamma/2)/(1-lambda_),2) * (1/pow(RR_plus,4)) * (pow(RR_plus,2)*WW+pow(WW,2)*RR_plus) );

	if(RR_plus>0) {
        FF_plus=.5*nb_strats_*pi_0*gamma;
		if(FF_plus>RR_plus) {
            FF_plus=RR_plus;
		}
		*F_plus=ceil(FF_plus);
		return FF_plus/RR_plus;
	} else {
		*F_plus=0;
		return 2;
	}

}

double FalseDiscoRate_minus(double pvalues[], double Perfs[], double pi_0, double gamma, double * R_minus, double * F_minus) {
	double FF_minus;
	double RR_minus=0;
	
	for(long s=0; s<nb_strats_; s++) {
		//superflu:
		//if((pvalues[s]<=gamma) && (pvalues[s]!=-1) && (Perfs[s]<0)) {
		if((pvalues[s]<=gamma) && (Perfs[s]<0)) {
			RR_minus++;
		}
	}
	*R_minus=RR_minus;

	if(RR_minus>0) {
        FF_minus=.5*nb_strats_*pi_0*gamma;
		if(FF_minus>RR_minus) {
            FF_minus=RR_minus;
		}
		*F_minus=ceil(FF_minus);
		return FF_minus/RR_minus;
	} else {
		*F_minus=0;
		return 2;
	}

}

double Compute_PI_A_plus(double pvalues[], double Perfs[], double pi_0, double gamma, double * sigma_PI_A_plus, double * sigma_PI_A_minus) {
	
	double W, R_plus, F_plus, FDR_plus, V_FDR_plus;
	double sigma_pi_0, sigma_R_plusM, sigma_PI_AA_plus;

	FDR_plus=FalseDiscoRate_plus(pvalues, Perfs, pi_0, gamma, &W, &R_plus, &F_plus, &V_FDR_plus);

	sigma_pi_0=sqrt( W*(nb_strats_-W)/ (pow((double)nb_strats_,3)*pow(1-lambda_,2)) );
	sigma_R_plusM=sqrt( (R_plus/nb_strats_)*(1-(R_plus/nb_strats_))/nb_strats_ );
	sigma_PI_AA_plus=sqrt( pow(sigma_R_plusM,2)+pow(gamma/2,2)*pow(sigma_pi_0,2)+2*(gamma/2)/(1-lambda_)*(R_plus/nb_strats_)*W/pow((double)nb_strats_,2) );
	*sigma_PI_A_plus=sigma_PI_AA_plus;
	*sigma_PI_A_minus=sqrt( pow(sigma_PI_AA_plus,2)+pow(sigma_pi_0,2)-2*(1/(1-lambda_))*(R_plus/nb_strats_)*W/pow((double)nb_strats_,2) -2*(gamma/2)*pow(sigma_pi_0,2) );

	return (R_plus-F_plus)/nb_strats_;

}

double Compute_PI_A_minus(double pvalues[], double Perfs[], double pi_0, double gamma) {
	
	double R_minus, F_minus, FDR_minus;

	FDR_minus=FalseDiscoRate_minus(pvalues, Perfs, pi_0, gamma, &R_minus, &F_minus);

	return (R_minus-F_minus)/nb_strats_;

}

