#include "Tools.h"

int FilterRule1(int oldS, long t, long * pt_extrema, double x, double * Prices) {
//first def of subsequent high/low
	double high, low;
	int S;
	switch(oldS) {
    case 1:
		high=FindHigh(Prices, *pt_extrema, t-1);
        if((Prices[t]-high)/high < -x) {
            S=-1;
            *pt_extrema=t;
		} else
            S=oldS;
        break;
	case -1:
		low=FindLow(Prices, *pt_extrema, t-1);
        if((Prices[t]-low)/low > x) {
		  	S=1;
		  	*pt_extrema=t;
		} else
            S=oldS;
        break;
	//case 0 (at beginning):
	default:
		high=FindHigh(Prices, *pt_extrema, t-1);
		low=FindLow(Prices, *pt_extrema, t-1);
		if((Prices[t]-low)/low > x) {
		 	S=1;
		 	*pt_extrema=t;
		} else if((Prices[t]-high)/high < -x) {
		 	S=-1;
		 	*pt_extrema=t;
		} else
		 	S=oldS;
	}	
	return S;
}

int FilterRule2(int oldS, long t, long * pt_extrema, double x, int e, double * Prices) {
//alternative def of subsequent high/low, no neutral position
	double high, low;
    int S;
    switch(oldS) {
    case 1:
		high=FindHigh2(Prices, *pt_extrema, t-1, e);
		if(high!=-1 && (Prices[t]-high)/high < -x) {
			S=-1;
			*pt_extrema=t;
		} else
            S=oldS;
        break;
	case -1:
		low=FindLow2(Prices, *pt_extrema, t-1, e);
		if(low!=-1 && (Prices[t]-low)/low > x) {
            S=1;
			*pt_extrema=t;
		} else
            S=oldS;
        break;
	//case 0 (at beginning):
	default:
		high=FindHigh2(Prices, *pt_extrema, t-1, e);
		low=FindLow2(Prices, *pt_extrema, t-1, e);
		if(low!=-1 && (Prices[t]-low)/low > x) {
            S=1;
			*pt_extrema=t;
		} else if(high!=-1 && (Prices[t]-high)/high < -x) {
            S=-1;
			*pt_extrema=t;
		} else
		 	S=oldS;
	}
	return S;
}

int FilterRule3(int oldS, long t, long * pt_extrema, long * pt_holding_period, double x, int c, double * Prices) {
//constant holding period, first def of subsequent high/low
	double high, low;
	int S;
	if((t-*pt_holding_period)<c) {
  		S=oldS;
	} else {
		high=FindHigh(Prices, *pt_extrema, t-1);
		low=FindLow(Prices, *pt_extrema, t-1);
		if((Prices[t]-low)/low > x) {
		 	S=1;
		 	*pt_holding_period=t;
			*pt_extrema=t+c-1;
		} else if((Prices[t]-high)/high < -x) {
		 	S=-1;
		 	*pt_holding_period=t;
			*pt_extrema=t+c-1;
		} else
		 	S=oldS;	
	}
	return S;
}

int FilterRule4(int oldS, long t, long * pt_extrema, double x, double y, double * Prices) {
//first def of subsequent high/low, neutral position
	double high, low;
	int S;
	switch(oldS) {
	case 1:
		high=FindHigh(Prices, *pt_extrema, t-1);
		if((Prices[t]-high)/high < -x) {
		  	S=-1;
		  	*pt_extrema=t;
		} else if((Prices[t]-high)/high < -y) {
		  	S=0;
		  	//*pt_extrema=t;
		} else
		    S=oldS;
		break;
	case -1:
		low=FindLow(Prices, *pt_extrema, t-1);
        if((Prices[t]-low)/low > x) {
		  	S=1;
		  	*pt_extrema=t;
		} else if((Prices[t]-low)/low > y) {
		  	S=0;
		  	//*pt_extrema=t;
		} else
		  	S=oldS;
		break;
	//case 0:
	default:
		high=FindHigh(Prices, *pt_extrema, t-1);
		low=FindLow(Prices, *pt_extrema, t-1);
		if((Prices[t]-low)/low > x) {
		 	S=1;
		 	*pt_extrema=t;
		} else if((Prices[t]-high)/high < -x) {
		 	S=-1;
		 	*pt_extrema=t;
		} else
		 	S=oldS;
	}
	return S;
}





