#include <cstdlib>
#include <cmath>

#include <direct.h>

#include <string>
#include <fstream>
#include <iostream>
#include <sstream>

#include <algorithm>
#include <vector>

#include "Umgebung.h"

#include "Tools.h"
#include "FDR_tools.h"
#include "FDR_portfolio.h"
#include "Rom_Wolf_portfolio.h"
#include "Strategies.h"
#include "Perf_tools.h"
#include "Infos.h"

using namespace std;

double RF_bis_test[N_];
double SR_ReturnsPorfolio_test[N_];

double DJ[TT_];
double RF[TT_];
double DJ_Returns[TT_];
double OBVI[TT_];
int SLOW[nb_strats_];
int NBER[TT_];
long IDX[B_][N_];

double Perfs[nb_perf_measures_][nb_strats_];
double Perfs_B[nb_perf_measures_][B_][nb_strats_];

int SSS[nb_strats_][N_];

double ReturnsPorfolio[N_];
double ReturnsPorfolio_RW[N_];

strat_struct my_table[nb_strats_];

double pvalues[nb_perf_measures_][nb_strats_];

int FDRplus_5_port[nb_strats_];
int FDRplus_5_port_2[nb_strats_];
int FDRminus_5_port[nb_strats_];
int FDRminus_5_port_2[nb_strats_];
int FDRplus_10_port[nb_strats_];
int FDRplus_10_port_2[nb_strats_];
int FDRminus_10_port[nb_strats_];
int FDRminus_10_port_2[nb_strats_];
int FDRexplo_port[nb_strats_];
int RW_port[nb_strats_];
int Best_port[nb_strats_];

int FDRplus_5_nbrules_bycateg[5];
int FDRplus_10_nbrules_bycateg[5];
int FDRexplo_nbrules_bycateg[5];

int FDRplus_5_nbrules_byhori[2];
int FDRplus_10_nbrules_byhori[2];
int FDRexplo_nbrules_byhori[2];

long NB_trades[nb_strats_];

infos_struct ALL_Infos[nb_strats_];
infos_struct FDRplus_5_port_Infos;
infos_struct FDRplus_10_port_Infos;
infos_struct FDRexplo_port_Infos;
infos_struct RW_port_Infos;
infos_struct Best_port_Infos;


template <class T>
void to_string(string & result, const T & t) {
	ostringstream oss; // create a stream
	oss << t; // insert value to stream
	result=oss.str(); // extract value and write it to result
}

int main() {

	int s, i_TC, i_perf;
	long t;

	double W, Rplus, Fplus, Rminus, Fminus, FDRplus_explo, FDRminus_explo;
	double FDRplus_5, FDRplus_5_2, FDRplus_10, FDRplus_10_2;
	double FDRminus_5, FDRminus_5_2, FDRminus_10, FDRminus_10_2;
	int FDRplus_5_portsize, FDRminus_5_portsize, FDRplus_10_portsize, FDRminus_10_portsize;
	int FDRexplo_portsize, RW_portsize;
	double sigma_FDRplus_explo, sigma_FDRplus_5_2, sigma_FDRplus_10_2;
	double pi_0;
	double pi_A_plus_035, pi_A_plus_040, pi_A_plus_045;
	double pi_A_minus_035, pi_A_minus_040, pi_A_minus_045;
	double sigma_pi_A_plus_035, sigma_pi_A_plus_040, sigma_pi_A_plus_045;
	double sigma_pi_A_minus_035, sigma_pi_A_minus_040, sigma_pi_A_minus_045;

	double perf_FDRplus_5=0;
	double perf_FDRplus_10=0;
	double perf_FDRexplo=0;
	double perf_RW=0;
	double perf_Bestport=0;
	double perf_Bestrule=0;

	double mu_FDRplus_5=0;
	double mu_FDRplus_10=0;
	double mu_FDRexplo=0;
	double mu_RW=0;
	double mu_Bestport=0;
	double mu_Bestrule=0;

	double nbtransac_FDR10_SR, nbtransac_RW_SR;

	int bestrule_idx;
	double BRC;

	string resultats_path, resultats_path_2, file_path;
	ofstream ResultsFile, Results2File, NB_tradesFiles, pvaluesFile, PerfsFile, 
		FDRplus_5_portFile, FDRminus_5_portFile, FDRplus_10_portFile, FDRminus_10_portFile,
		FDRexplo_portFile, RW_portFile, ReturnsPorfolioFile;
	//ofstream Perfs_BFile;
	string tmp;

	resultats_path_2=boulot_path_+"\\DATA\\dataprojet1\\resultats_post20110716";
	_mkdir(resultats_path_2.c_str());
	resultats_path_2=resultats_path_2+"\\strats";
	_mkdir(resultats_path_2.c_str());
	to_string(tmp, strats_categ_);
	resultats_path_2=resultats_path_2+"\\strats_categ_"+tmp;
	_mkdir(resultats_path_2.c_str());
	resultats_path_2=resultats_path_2+"\\P_"+period_;
	_mkdir(resultats_path_2.c_str());

	//Begin Reading Data +++++++++++++++++++++++++++++++++++++++++++++++
	cout << "Loading data..." << endl;
	string string_DJ=boulot_path_+"\\DATA\\dataprojet1\\data\\DJ_P"+period_+".txt";
	string string_RF=boulot_path_+"\\DATA\\dataprojet1\\data\\RF_P"+period_+".txt";
	string string_OBVI=boulot_path_+"\\DATA\\dataprojet1\\data\\OBVI_P"+period_+".txt";
	string string_SLOW=boulot_path_+"\\DATA\\dataprojet1\\data\\SLOW.txt";
	string string_IDX=boulot_path_+"\\DATA\\dataprojet1\\data\\IDX_P"+period_+".txt";

	ifstream InputFile_DJ;
	ifstream InputFile_RF;
	ifstream InputFile_OBVI;
	ifstream InputFile_SLOW;
	ifstream InputFile_IDX;

	InputFile_DJ.open(string_DJ.c_str());
	InputFile_RF.open(string_RF.c_str());
	InputFile_OBVI.open(string_OBVI.c_str());
	InputFile_SLOW.open(string_SLOW.c_str());
	InputFile_IDX.open(string_IDX.c_str());

	string s_DJ;
	string s_RF;
	string s_OBVI;
	string s_SLOW;
	string s_IDX;

	for(t=0; t<TT_; t++) {
		getline(InputFile_DJ, s_DJ);
		getline(InputFile_RF, s_RF);
		getline(InputFile_OBVI, s_OBVI);
				
		DJ[t]=atof(s_DJ.c_str());
		RF[t]=atof(s_RF.c_str());
		OBVI[t]=atof(s_OBVI.c_str());
	}
	for(int b=0; b<B_; b++) {
		for(t=0; t<N_; t++) {
			getline(InputFile_IDX, s_IDX);
			IDX[b][t]=(int)atof(s_IDX.c_str());
		}
	}
	for(s=0; s<nb_strats_; s++) {
		getline(InputFile_SLOW, s_SLOW);
		SLOW[s]=(int)atof(s_SLOW.c_str());
	}

	InputFile_DJ.close();
	InputFile_RF.close();
	InputFile_OBVI.close();
	InputFile_SLOW.close();
	InputFile_IDX.close();
	//End Reading Data +++++++++++++++++++++++++++++++++++++++++++++++

	//Begin Computing Returns +++++++++++++++++++++++++++++++++++++++++++++++
	for(t=1; t<TT_; t++) {
		DJ_Returns[t]=(DJ[t]-DJ[t-1])/DJ[t-1];
	}

	for(t=0; t<TT_; t++) {
		RF[t]=log(1+RF[t]/100)/252;
	}
	//End Computing Returns +++++++++++++++++++++++++++++++++++++++++++++++

	double perf_DJ[nb_perf_measures_];
	//perf_DJ[0]=T_fin_year_*(log(DJ[T_])-log(DJ[R_-1]))/N_;
	perf_DJ[0]=T_fin_year_*Sum(&DJ_Returns[R_], N_)/N_;
	perf_DJ[1]=SharpeRatio(&DJ_Returns[R_], &RF[R_], N_);

	Strats(strats_categ_, R_, T_, SSS, DJ, OBVI);

	PrintRetsAuxFct(SSS, R_, T_, 0, 0, DJ_Returns, RF, Perfs);

	cout << endl << "fini!!";

	//keep console open when using visual studio
	string fin;
	getline(cin, fin);
	
	//return 0;
	
}
	
	
	




